
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Report &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <h1>Source code for Report</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">Nasa_Classes</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">torch</span> <span class="k">as</span> <span class="nn">th</span>
<span class="kn">import</span> <span class="nn">pickle</span>
<span class="kn">import</span> <span class="nn">re</span>


<div class="viewcode-block" id="Report"><a class="viewcode-back" href="../sphinx/Report.html#Report.Report">[docs]</a><span class="k">def</span> <span class="nf">Report</span><span class="p">(</span><span class="n">Model</span><span class="p">,</span> <span class="n">train_loader</span><span class="p">,</span> <span class="n">valid_loader</span><span class="p">,</span> <span class="n">Training_info</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
           <span class="n">file_name</span><span class="o">=</span><span class="s1">&#39;Report&#39;</span><span class="p">,</span> <span class="n">remove_files</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This function creates a Report text file containing information about the</span>
<span class="sd">    model&#39;s training and saves important information in separate files.</span>

<span class="sd">    This function is called by the :py:func:`Training.Train` function of the</span>
<span class="sd">    :py:mod:`Training` module at the end of the last epoch (if ``report=True``).</span>

<span class="sd">    The text report will include:</span>

<span class="sd">    - Information about the model itself (specificities).</span>
<span class="sd">    - Training information.</span>
<span class="sd">        Learning rate, number of epochs, batch size, best and last epochs and</span>
<span class="sd">        their losses, loss function and optimizer.</span>
<span class="sd">    - Information about the training and validation datasets.</span>

<span class="sd">    This function will also save the best and last epochs&#39; models</span>
<span class="sd">    (`best_model.txt` and `base_model.txt`) and the Training_Class object with</span>
<span class="sd">    all of the training information.</span>

<span class="sd">    .. note::</span>
<span class="sd">        The model&#39;s parameters are changed to the best epoch&#39;s.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    Model : torch.nn.Module</span>
<span class="sd">        The trained model.</span>
<span class="sd">    train_loader : torch.utils.data.DataLoader</span>
<span class="sd">        The training dataset&#39;s DataLoader class.</span>
<span class="sd">    valid_loader : torch.utils.data.DataLoader</span>
<span class="sd">        The validation dataset&#39;s DataLoader class.</span>
<span class="sd">    Training_info : Training_Class, optional</span>
<span class="sd">        The Training_Class where the training information is stored.</span>
<span class="sd">    file_name : str, default = &#39;Report&#39;</span>
<span class="sd">        The name of the report file.</span>
<span class="sd">    remove_files : bool, default = False</span>
<span class="sd">        Whether or not to remove the Epochs&#39; files after saving the last and</span>
<span class="sd">        best epochs&#39; results. This may be desirable if many epochs were run.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># Opening the file</span>
    <span class="n">FILE</span> <span class="o">=</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span> <span class="o">+</span> <span class="s1">&#39;.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;w&#39;</span><span class="p">)</span>
    <span class="c1"># Writing about the model</span>
    <span class="n">FILE</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s1">&#39;MODEL</span><span class="se">\n</span><span class="s1">&#39;</span> <span class="o">+</span> <span class="n">Model</span><span class="o">.</span><span class="n">report</span><span class="p">())</span>

    <span class="c1"># Writing about the training itself:</span>
    <span class="k">if</span> <span class="n">Training_info</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">FILE</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1">TRAINING</span><span class="se">\n</span><span class="s1">&#39;</span> <span class="o">+</span> <span class="n">Training_info</span><span class="o">.</span><span class="n">report</span><span class="p">())</span>

    <span class="c1"># Writing about the training dataset:</span>
    <span class="n">FILE</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1">TRAINING DATASET</span><span class="se">\n</span><span class="s1">&#39;</span>
               <span class="o">+</span> <span class="s1">&#39;  Batch size: &#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">train_loader</span><span class="o">.</span><span class="n">batch_size</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span>
               <span class="o">+</span> <span class="n">train_loader</span><span class="o">.</span><span class="n">dataset</span><span class="o">.</span><span class="n">report</span><span class="p">()</span>
               <span class="p">)</span>

    <span class="c1"># Writing about the validation dataset:</span>
    <span class="n">FILE</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1">VALIDATION DATASET</span><span class="se">\n</span><span class="s1">&#39;</span>
               <span class="o">+</span> <span class="s1">&#39;  Batch Size: &#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">valid_loader</span><span class="o">.</span><span class="n">batch_size</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span>
               <span class="o">+</span> <span class="n">valid_loader</span><span class="o">.</span><span class="n">dataset</span><span class="o">.</span><span class="n">report</span><span class="p">()</span>
               <span class="p">)</span>

    <span class="c1"># Closing the file:</span>
    <span class="n">FILE</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>

    <span class="c1"># Saving the Training information class</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;Training_Info.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;wb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">Training_info</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>

    <span class="c1"># Saving dataset information that can be loaded by the load_save:</span>
    <span class="n">train_loader</span><span class="o">.</span><span class="n">dataset</span><span class="o">.</span><span class="n">dataset_info</span><span class="p">(</span><span class="s1">&#39;train&#39;</span><span class="p">)</span>
    <span class="n">valid_loader</span><span class="o">.</span><span class="n">dataset</span><span class="o">.</span><span class="n">dataset_info</span><span class="p">(</span><span class="s1">&#39;valid&#39;</span><span class="p">)</span>

    <span class="c1"># Saving the datasets: (they were too big so I&#39;ve disabled this option)</span>
    <span class="c1"># with open(&#39;train_dataset.txt&#39;, &#39;wb&#39;) as f:</span>
    <span class="c1">#     pickle.dump(train_loader.dataset, f)</span>
    <span class="c1">#</span>
    <span class="c1"># with open(&#39;valid_dataset.txt&#39;, &#39;wb&#39;) as f:</span>
    <span class="c1">#     pickle.dump(valid_loader.dataset, f)</span>

    <span class="c1"># Saving the last epoch&#39;s model:</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">Model</span><span class="o">.</span><span class="n">update_norm</span><span class="p">()</span>
    <span class="k">except</span> <span class="ne">AttributeError</span><span class="p">:</span>
        <span class="k">pass</span>

    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;base_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;wb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">Model</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="s1">&#39;cpu&#39;</span><span class="p">)</span>
        <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">Model</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>

    <span class="n">th</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="n">Model</span><span class="o">.</span><span class="n">state_dict</span><span class="p">(),</span> <span class="s1">&#39;base_model_dict.txt&#39;</span><span class="p">)</span>

    <span class="c1"># Saving the best epoch&#39;s model:</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Epochs&#39;</span><span class="p">)</span>
        <span class="n">Model</span><span class="o">.</span><span class="n">load_state_dict</span><span class="p">(</span>
            <span class="n">th</span><span class="o">.</span><span class="n">load</span><span class="p">(</span>
                <span class="s1">&#39;Epoch_&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">Training_info</span><span class="o">.</span><span class="n">best_epoch</span><span class="o">.</span><span class="n">nb</span> <span class="o">+</span> <span class="mi">1</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span><span class="p">,</span>
                <span class="n">map_location</span><span class="o">=</span><span class="n">th</span><span class="o">.</span><span class="n">device</span><span class="p">(</span><span class="s1">&#39;cpu&#39;</span><span class="p">)</span>
            <span class="p">)</span>
        <span class="p">)</span>
        <span class="c1"># Now that we have already loaded the best epoch&#39;s state_dict(),</span>
        <span class="c1"># we can delete the epochs&#39; files</span>
        <span class="k">if</span> <span class="n">remove_files</span><span class="p">:</span>            <span class="c1"># If we want to</span>
            <span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>    <span class="c1"># All files in the folder</span>
            <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
                <span class="c1"># Only take into account the Epoch ones (just to be safe)</span>
                <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;Epoch_\d</span><span class="si">{1}</span><span class="s1">&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">match</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="k">continue</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
            <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../&#39;</span><span class="p">)</span>
            <span class="n">os</span><span class="o">.</span><span class="n">rmdir</span><span class="p">(</span><span class="s1">&#39;Epochs&#39;</span><span class="p">)</span>  <span class="c1"># Remove the empty directory altogether</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../&#39;</span><span class="p">)</span>

        <span class="c1"># Save the model with the best epoch&#39;s state_dict()</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">Model</span><span class="o">.</span><span class="n">update_norm</span><span class="p">()</span>
        <span class="k">except</span> <span class="ne">AttributeError</span><span class="p">:</span>
            <span class="k">pass</span>
        
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;best_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;wb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">Model</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>

        <span class="n">th</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="n">Model</span><span class="o">.</span><span class="n">state_dict</span><span class="p">(),</span> <span class="s1">&#39;best_model_dict.txt&#39;</span><span class="p">)</span>

    <span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Epochs folder not created.&#39;</span><span class="p">)</span></div>

<div class="viewcode-block" id="Training_Class"><a class="viewcode-back" href="../sphinx/Report.html#Report.Training_Class">[docs]</a><span class="k">class</span> <span class="nc">Training_Class</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This class was created to keep track of training and epoch information.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    N_epochs : int</span>
<span class="sd">        Number of epochs in the training.</span>
<span class="sd">    loss_fn : a torch.nn. Loss function</span>
<span class="sd">        The loss function used in training.</span>
<span class="sd">    optimizer : a torch.nn Optimizer</span>
<span class="sd">        The optimizer used in training.</span>
<span class="sd">    learning_rate : float</span>
<span class="sd">        Training learning_rate.</span>
<span class="sd">    batch_size : int</span>
<span class="sd">        Training batch_size.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    nb_epochs : int</span>
<span class="sd">        The number of epochs.</span>
<span class="sd">    loss_fn : a torch.nn. Loss function</span>
<span class="sd">        The loss function used in training.</span>
<span class="sd">    optimizer : a torch.nn Optimizer</span>
<span class="sd">        The optimizer used in training.</span>
<span class="sd">    learning_rate : float</span>
<span class="sd">        Training learning_rate.</span>
<span class="sd">    batch_size : int</span>
<span class="sd">        Training batch_size.</span>
<span class="sd">    epoch : list[Epoch_Class]</span>
<span class="sd">        A list of all of the training epochs. To add an epoch to this list, the</span>
<span class="sd">        method ``add_epoch`` is used. See Epoch_Class for more.</span>
<span class="sd">    best_epoch : Epoch_Class</span>
<span class="sd">        Epoch information about the best epoch. It is defined through the method</span>
<span class="sd">        ``best_epoch``.</span>
<span class="sd">    trains : list[Training_Class]</span>
<span class="sd">        A list with the information of the previous times the model has been</span>
<span class="sd">        trained. To add a Training_Class to the list, the method ``add_epoch``</span>
<span class="sd">        is used.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">N_epochs</span><span class="p">,</span> <span class="n">loss_fn</span><span class="p">,</span> <span class="n">optimizer</span><span class="p">,</span> <span class="n">learning_rate</span><span class="p">,</span> <span class="n">batch_size</span><span class="p">):</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">nb_epochs</span> <span class="o">=</span> <span class="n">N_epochs</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">loss_fn</span> <span class="o">=</span> <span class="n">loss_fn</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">optimizer</span> <span class="o">=</span> <span class="n">optimizer</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">learning_rate</span> <span class="o">=</span> <span class="n">learning_rate</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">batch_size</span> <span class="o">=</span> <span class="n">batch_size</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">epoch</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">trains</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">supp_info</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span>

<div class="viewcode-block" id="Training_Class.add_epoch"><a class="viewcode-back" href="../sphinx/Report.html#Report.Training_Class.add_epoch">[docs]</a>    <span class="k">def</span> <span class="nf">add_epoch</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">train_loss</span><span class="p">,</span> <span class="n">valid_loss</span><span class="p">,</span> <span class="n">nb</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Adds an epoch to self.epoch list. The epoch itself is a separate</span>
<span class="sd">        Epoch_Class object.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        train_loss : th.Tensor</span>
<span class="sd">            The training dataset loss.</span>
<span class="sd">        valid_loss : th.Tensor</span>
<span class="sd">            The validation dataset loss.</span>
<span class="sd">        nb : int</span>
<span class="sd">            The epoch&#39;s number</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">epoch</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Epoch_Class</span><span class="p">(</span><span class="n">train_loss</span><span class="p">,</span> <span class="n">valid_loss</span><span class="p">,</span> <span class="n">nb</span><span class="p">))</span></div>

<div class="viewcode-block" id="Training_Class.best_epoch_method"><a class="viewcode-back" href="../sphinx/Report.html#Report.Training_Class.best_epoch_method">[docs]</a>    <span class="k">def</span> <span class="nf">best_epoch_method</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Calculates which epoch has the lowest validation loss and defines it</span>
<span class="sd">        as the attribute best_epoch (Epoch_Class).</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">epoch</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">:</span>
            <span class="n">valid_loss</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">zeros</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">epoch</span><span class="p">))</span>

            <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">epoch</span><span class="p">)):</span>
                <span class="n">valid_loss</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">epoch</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">valid_loss</span>

            <span class="n">nb</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">argmin</span><span class="p">(</span><span class="n">valid_loss</span><span class="p">)</span><span class="o">.</span><span class="n">item</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">best_epoch</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">Epoch_Class</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">epoch</span><span class="p">[</span><span class="n">nb</span><span class="p">]</span><span class="o">.</span><span class="n">train_loss</span><span class="p">,</span>
                                               <span class="bp">self</span><span class="o">.</span><span class="n">epoch</span><span class="p">[</span><span class="n">nb</span><span class="p">]</span><span class="o">.</span><span class="n">valid_loss</span><span class="p">,</span> <span class="n">nb</span><span class="p">)</span>

        <span class="k">else</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;No epochs saved&#39;</span><span class="p">)</span></div>

<div class="viewcode-block" id="Training_Class.add_train"><a class="viewcode-back" href="../sphinx/Report.html#Report.Training_Class.add_train">[docs]</a>    <span class="k">def</span> <span class="nf">add_train</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">Training_info</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Stores information from a past training when a model has already been</span>
<span class="sd">        trained before.</span>
<span class="sd">        Not very useful and not very well implemented, works just as a history</span>
<span class="sd">        and is very rarely used.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        Training_info : Training_Class</span>
<span class="sd">            The training information we are aggregating.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">trains</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Training_info</span><span class="p">)</span></div>

<div class="viewcode-block" id="Training_Class.supplementary_information"><a class="viewcode-back" href="../sphinx/Report.html#Report.Training_Class.supplementary_information">[docs]</a>    <span class="k">def</span> <span class="nf">supplementary_information</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">string</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Adds supplementary information to the report method.</span>

<span class="sd">        In order to adjust it to the formatting of the report, it&#39;s recommended</span>
<span class="sd">        to start the supplementary information with two spaces and skip a line</span>
<span class="sd">        (&#39;\n&#39;) for each new item.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        string : str</span>
<span class="sd">            The string we want to add to the report method.</span>

<span class="sd">        &quot;&quot;&quot;</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">supp_info</span> <span class="o">+=</span> <span class="n">string</span></div>

<div class="viewcode-block" id="Training_Class.report"><a class="viewcode-back" href="../sphinx/Report.html#Report.Training_Class.report">[docs]</a>    <span class="k">def</span> <span class="nf">report</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Creates a little report with all of the information about the class.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">            A string with the report information.</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">string</span> <span class="o">=</span> \
            <span class="sa">f</span><span class="s2">&quot;  Number of Epochs: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">nb_epochs</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>\
            <span class="sa">f</span><span class="s2">&quot;  Learning rate: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">learning_rate</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>\
            <span class="sa">f</span><span class="s2">&quot;  Batch size: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">batch_size</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>\
            <span class="sa">f</span><span class="s2">&quot;  Epoch with smallest validation loss: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">best_epoch</span><span class="o">.</span><span class="n">nb</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>\
            <span class="sa">f</span><span class="s2">&quot;    (Epoch number starting at 0)</span><span class="se">\n</span><span class="s2">&quot;</span>\
            <span class="sa">f</span><span class="s2">&quot;    Training loss: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">best_epoch</span><span class="o">.</span><span class="n">train_loss</span><span class="o">.</span><span class="n">item</span><span class="p">()</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>\
            <span class="sa">f</span><span class="s2">&quot;    Validation loss: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">best_epoch</span><span class="o">.</span><span class="n">valid_loss</span><span class="o">.</span><span class="n">item</span><span class="p">()</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>\
            <span class="sa">f</span><span class="s2">&quot;  Last epoch&#39;s loss</span><span class="se">\n</span><span class="s2">&quot;</span>\
            <span class="sa">f</span><span class="s2">&quot;    Training loss: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">epoch</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">train_loss</span><span class="o">.</span><span class="n">item</span><span class="p">()</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>\
            <span class="sa">f</span><span class="s2">&quot;    Validation loss: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">epoch</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">valid_loss</span><span class="o">.</span><span class="n">item</span><span class="p">()</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>\
            <span class="sa">f</span><span class="s2">&quot;  Loss function: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">loss_fn</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>\
            <span class="sa">f</span><span class="s2">&quot;  Optimizer: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">optimizer</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>\
            <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">supp_info</span><span class="si">}</span><span class="s2">&quot;</span>

        <span class="k">return</span> <span class="n">string</span></div>


<div class="viewcode-block" id="Training_Class.Epoch_Class"><a class="viewcode-back" href="../sphinx/Report.html#Report.Training_Class.Epoch_Class">[docs]</a>    <span class="k">class</span> <span class="nc">Epoch_Class</span><span class="p">:</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        A class for keeping track of the training epochs.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        train_loss : th.Tensor</span>
<span class="sd">            The training dataset loss.</span>
<span class="sd">        valid_loss : th.Tensor</span>
<span class="sd">            The validation dataset loss.</span>
<span class="sd">        nb : int</span>
<span class="sd">            The epoch&#39;s number</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">train_loss</span><span class="p">,</span> <span class="n">valid_loss</span><span class="p">,</span> <span class="n">nb</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">train_loss</span> <span class="o">=</span> <span class="n">train_loss</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">valid_loss</span> <span class="o">=</span> <span class="n">valid_loss</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">nb</span> <span class="o">=</span> <span class="n">nb</span></div></div>
</pre></div>

              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>